---
title: CanvasCaptureMediaStreamTrack.requestFrame()
slug: Web/API/CanvasCaptureMediaStreamTrack/requestFrame
tags:
  - Canvas
  - CanvasCaptureMediaStream
  - DOM
  - Experimental
  - Frame Capture
  - Media
  - Method
  - Reference
  - requestFrame
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The {{domxref("CanvasCaptureMediaStreamTrack")}} method <strong><code>requestFrame()</code></strong> requests that a frame be captured from the canvas and sent to the stream.</span> Applications that need to carefully control the timing of rendering and frame capture can use <code>requestFrame()</code> to directly specify when it's time to capture a frame.</p>

<p>To prevent automatic capture of frames, so that frames are only captured when <code>requestFrame()</code> is called, specify a value of 0 for the {{domxref("HTMLCanvasElement.captureStream", "captureStream()")}} method when creating the stream.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>stream</var>.requestFrame();
</pre>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code></p>

<h2 id="Usage_notes">Usage notes</h2>

<p>There is currently an issue flagged in the specification pointing out that at this time, no exceptions are being thrown if the canvas isn't origin-clean. This may change in the future, so it would be wise to plan ahead and watch for exceptions such as <code>SecurityError</code> (although the specific error that might be thrown is not mentioned in the spec, this is a likely candidate).</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">// Find the canvas element to capture
var canvasElt = document.getElementsByTagName("canvas")[0];

// Get the stream
var stream = canvasElt.captureStream(25); // 25 FPS

// Send the current state of the canvas as a frame to the stream
stream.getVideoTracks()[0].requestFrame();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Capture DOM Elements', '#dom-canvascapturemediastreamtrack-requestframe', 'CanvasCaptureMediaStream.requestFrame()')}}</td>
   <td>{{Spec2('Media Capture DOM Elements')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasCaptureMediaStreamTrack.requestFrame")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasCaptureMediaStream")}}, the interface it belongs to.</li>
 <li>{{HTMLElement("canvas")}}</li>
</ul>
